/**
 * POCDMT000040Section.java
 *
 * File generated from the cdaepsos3::POCDMT000040Section uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos3;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Section.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Section", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"title",
	"text",
	"confidentialityCode",
	"languageCode",
	"subject",
	"author",
	"informant",
	"entry",
	"component",
	"classCode",
	"iD1",
	"moodCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Section")
public class POCDMT000040Section implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.II id;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE code;
	@XmlElement(name = "title", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ST title;
	@XmlElement(name = "text", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.nblock.StrucDocText text;
	@XmlElement(name = "confidentialityCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE confidentialityCode;
	@XmlElement(name = "languageCode", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CS languageCode;
	@XmlElement(name = "subject", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Subject subject;
	@XmlElement(name = "author", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> author;
	@XmlElement(name = "informant", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> informant;
	@XmlElement(name = "entry", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Entry> entry;
	@XmlElement(name = "component", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Component5> component;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.ActClass classCode;
	@XmlAttribute(name = "ID")
	public String iD1;
	@XmlAttribute(name = "moodCode")
	public net.ihe.gazelle.voc.ActMood moodCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlTransient
	private Object __parent;
	
	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
		this.__parent = parent;
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.datatypes.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.datatypes.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return title.
	 * @return title
	 */
	public net.ihe.gazelle.datatypes.ST getTitle() {
	    return title;
	}
	
	/**
	 * Set a value to attribute title.
	 * @param title.
	 */
	public void setTitle(net.ihe.gazelle.datatypes.ST title) {
	    this.title = title;
	}
	
	
	
	
	/**
	 * Return text.
	 * @return text
	 */
	public net.ihe.gazelle.nblock.StrucDocText getText() {
	    return text;
	}
	
	/**
	 * Set a value to attribute text.
	 * @param text.
	 */
	public void setText(net.ihe.gazelle.nblock.StrucDocText text) {
	    this.text = text;
	}
	
	
	
	
	/**
	 * Return confidentialityCode.
	 * @return confidentialityCode
	 */
	public net.ihe.gazelle.datatypes.CE getConfidentialityCode() {
	    return confidentialityCode;
	}
	
	/**
	 * Set a value to attribute confidentialityCode.
	 * @param confidentialityCode.
	 */
	public void setConfidentialityCode(net.ihe.gazelle.datatypes.CE confidentialityCode) {
	    this.confidentialityCode = confidentialityCode;
	}
	
	
	
	
	/**
	 * Return languageCode.
	 * @return languageCode
	 */
	public net.ihe.gazelle.datatypes.CS getLanguageCode() {
	    return languageCode;
	}
	
	/**
	 * Set a value to attribute languageCode.
	 * @param languageCode.
	 */
	public void setLanguageCode(net.ihe.gazelle.datatypes.CS languageCode) {
	    this.languageCode = languageCode;
	}
	
	
	
	
	/**
	 * Return subject.
	 * @return subject
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040Subject getSubject() {
	    return subject;
	}
	
	/**
	 * Set a value to attribute subject.
	 * @param subject.
	 */
	public void setSubject(net.ihe.gazelle.cdaepsos3.POCDMT000040Subject subject) {
	    this.subject = subject;
	}
	
	
	
	
	/**
	 * Return author.
	 * @return author
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> getAuthor() {
		if (author == null) {
	        author = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Author>();
	    }
	    return author;
	}
	
	/**
	 * Set a value to attribute author.
	 * @param author.
	 */
	public void setAuthor(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Author> author) {
	    this.author = author;
	}
	
	
	
	/**
	 * Add a author to the author collection.
	 * @param author_elt Element to add.
	 */
	public void addAuthor(net.ihe.gazelle.cdaepsos3.POCDMT000040Author author_elt) {
	    this.getAuthor().add(author_elt);
	}
	
	/**
	 * Remove a author to the author collection.
	 * @param author_elt Element to remove
	 */
	public void removeAuthor(net.ihe.gazelle.cdaepsos3.POCDMT000040Author author_elt) {
	    this.getAuthor().remove(author_elt);
	}
	
	/**
	 * Return informant.
	 * @return informant
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> getInformant() {
		if (informant == null) {
	        informant = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12>();
	    }
	    return informant;
	}
	
	/**
	 * Set a value to attribute informant.
	 * @param informant.
	 */
	public void setInformant(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12> informant) {
	    this.informant = informant;
	}
	
	
	
	/**
	 * Add a informant to the informant collection.
	 * @param informant_elt Element to add.
	 */
	public void addInformant(net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant_elt) {
	    this.getInformant().add(informant_elt);
	}
	
	/**
	 * Remove a informant to the informant collection.
	 * @param informant_elt Element to remove
	 */
	public void removeInformant(net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant_elt) {
	    this.getInformant().remove(informant_elt);
	}
	
	/**
	 * Return entry.
	 * @return entry
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Entry> getEntry() {
		if (entry == null) {
	        entry = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Entry>();
	    }
	    return entry;
	}
	
	/**
	 * Set a value to attribute entry.
	 * @param entry.
	 */
	public void setEntry(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Entry> entry) {
	    this.entry = entry;
	}
	
	
	
	/**
	 * Add a entry to the entry collection.
	 * @param entry_elt Element to add.
	 */
	public void addEntry(net.ihe.gazelle.cdaepsos3.POCDMT000040Entry entry_elt) {
	    this.getEntry().add(entry_elt);
	}
	
	/**
	 * Remove a entry to the entry collection.
	 * @param entry_elt Element to remove
	 */
	public void removeEntry(net.ihe.gazelle.cdaepsos3.POCDMT000040Entry entry_elt) {
	    this.getEntry().remove(entry_elt);
	}
	
	/**
	 * Return component.
	 * @return component
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Component5> getComponent() {
		if (component == null) {
	        component = new ArrayList<net.ihe.gazelle.cdaepsos3.POCDMT000040Component5>();
	    }
	    return component;
	}
	
	/**
	 * Set a value to attribute component.
	 * @param component.
	 */
	public void setComponent(List<net.ihe.gazelle.cdaepsos3.POCDMT000040Component5> component) {
	    this.component = component;
	}
	
	
	
	/**
	 * Add a component to the component collection.
	 * @param component_elt Element to add.
	 */
	public void addComponent(net.ihe.gazelle.cdaepsos3.POCDMT000040Component5 component_elt) {
	    this.getComponent().add(component_elt);
	}
	
	/**
	 * Remove a component to the component collection.
	 * @param component_elt Element to remove
	 */
	public void removeComponent(net.ihe.gazelle.cdaepsos3.POCDMT000040Component5 component_elt) {
	    this.getComponent().remove(component_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.ActClass getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.ActClass classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return iD1.
	 * @return iD1
	 */
	public String getID1() {
	    return iD1;
	}
	
	/**
	 * Set a value to attribute iD1.
	 * @param iD1.
	 */
	public void setID1(String iD1) {
	    this.iD1 = iD1;
	}
	
	/**
	 * Return iD1.
	 * @return iD1
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public String getiD1() {
	    return iD1;
	}
	
	/**
	 * Set a value to attribute iD1.
	 * @param iD1.
	 * Generated for the use on jsf pages
	 */
	 @Deprecated
	public void setiD1(String iD1) {
	    this.iD1 = iD1;
	}
	
	
	
	/**
	 * Return moodCode.
	 * @return moodCode
	 */
	public net.ihe.gazelle.voc.ActMood getMoodCode() {
	    return moodCode;
	}
	
	/**
	 * Set a value to attribute moodCode.
	 * @param moodCode.
	 */
	public void setMoodCode(net.ihe.gazelle.voc.ActMood moodCode) {
	    this.moodCode = moodCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return __parent.
	 * @return __parent
	 */
	public Object get__parent() {
	    return __parent;
	}
	
	/**
	 * Set a value to attribute __parent.
	 * @param __parent.
	 */
	public void set__parent(Object __parent) {
	    this.__parent = __parent;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos3");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Section").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	/**
	* method validateByXPATHV2
	*
	*/
	public boolean validateByXPATHV2(String xpath){
		Boolean res = false;
		org.w3c.dom.Node _xmlNode = this.get_xmlNodePresentation();
		try {
			res = net.ihe.gazelle.gen.common.XpathUtils.evaluateByNode(_xmlNode, xpath);
		} catch (Exception e) {
			res = false;
		}
		return res;
	}
	
	
		

	/**
	 * Description of the method getAllSections.
	 *
	 * @return ret
	 */
	public List<net.ihe.gazelle.cdaepsos3.POCDMT000040Section> getAllSections() {
		List<POCDMT000040Section> res = new ArrayList<POCDMT000040Section>();
			for (POCDMT000040Component5 comp : this.getComponent()) {
				if (comp.getSection() != null){
					res.add(comp.getSection());
				}
			}
			return res;
	}
		

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Section pOCDMT000040Section, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Section != null){
   			cvm.validate(pOCDMT000040Section, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Section.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Section.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Section.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.II.validateByModule(pOCDMT000040Section.getId(), _location + "/id", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Section.getCode(), _location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ST.validateByModule(pOCDMT000040Section.getTitle(), _location + "/title", cvm, diagnostic);
			net.ihe.gazelle.nblock.StrucDocText.validateByModule(pOCDMT000040Section.getText(), _location + "/text", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Section.getConfidentialityCode(), _location + "/confidentialityCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CS.validateByModule(pOCDMT000040Section.getLanguageCode(), _location + "/languageCode", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040Subject.validateByModule(pOCDMT000040Section.getSubject(), _location + "/subject", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Author author: pOCDMT000040Section.getAuthor()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Author.validateByModule(author, _location + "/author[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12 informant: pOCDMT000040Section.getInformant()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Informant12.validateByModule(informant, _location + "/informant[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Entry entry: pOCDMT000040Section.getEntry()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Entry.validateByModule(entry, _location + "/entry[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

			{
				int i = 0;
				for (net.ihe.gazelle.cdaepsos3.POCDMT000040Component5 component: pOCDMT000040Section.getComponent()){
					net.ihe.gazelle.cdaepsos3.POCDMT000040Component5.validateByModule(component, _location + "/component[" + i + "]", cvm, diagnostic);
					i++;
				}
			}

    	}
    }

}